package kz.arta.synergy.pojo;

import kz.arta.synergy.api.asforms.annotations.*;
import kz.arta.synergy.api.asforms.pojo.AsForm;
import kz.arta.synergy.api.asforms.pojo.AsFormData;
import kz.arta.synergy.api.asforms.pojo.ComponentTypes;

import java.util.Date;
import java.util.List;

/**
 * @author raimbek
 * @since 09.11.2016
 */
public class TestForm extends AsForm {

    @TextBox("text_input")
    private String textInput;

    @KeyValue
    @NumericInput("numeric_input_key")
    private String numericInputKey;

    @NumericInput("numeric_input_value")
    private String numericInputValue;

    @Cmp(id = "file", type = ComponentTypes.FILE)
    private AsFormData file;

    @TextBox("double_input")
    private Double doubleValue;

    @TextBox("integer_input")
    private Integer integerValue;

    @DateCmp
    private Date date;

    @DateCmp
    private Date nullDate;

    public String getTextInput() {
        return textInput;
    }

    public void setTextInput(String textInput) {
        this.textInput = textInput;
    }

    public String getNumericInputKey() {
        return numericInputKey;
    }

    public void setNumericInputKey(String numericInputKey) {
        this.numericInputKey = numericInputKey;
    }

    public String getNumericInputValue() {
        return numericInputValue;
    }

    public void setNumericInputValue(String numericInputValue) {
        this.numericInputValue = numericInputValue;
    }

    public AsFormData getFile() {
        return file;
    }

    public void setFile(AsFormData file) {
        this.file = file;
    }

    public Double getDoubleValue() {
        return doubleValue;
    }

    public void setDoubleValue(Double doubleValue) {
        this.doubleValue = doubleValue;
    }

    public int getIntegerValue() {
        return integerValue;
    }

    public void setIntegerValue(Integer integerValue) {
        this.integerValue = integerValue;
    }

    @Table(id = "table_cmp", type = TableCmp.class)
    private List<TableCmp> tableData;

    public List<TableCmp> getTableData() {
        return tableData;
    }

    public void setTableData(List<TableCmp> tableData) {
        this.tableData = tableData;
    }

    public Date getDate() {
        return date;
    }

    public void setDate(Date date) {
        this.date = date;
    }

    public Date getNullDate() {
        return nullDate;
    }

    public void setNullDate(Date nullDate) {
        this.nullDate = nullDate;
    }
}
